CC     = gcc
CXX    = g++
LD     = ld
AR     = ar
YACC   = bison -y
YFLAGS = -v
LEX    = flex

# Linux etc.
LIBEXT = .a
OBJEXT = .o
EXEEXT =
GCCFLAGS = -Wall -MMD -O2
LINKFLAGS = -static
LINKLIB = ld -r -o $@ $^
LINKBIN = $(CXX) $(LINKFLAGS) -o $@ $(LIBS)

# Linux 32-bit (on a 64-bit platform)
# LIBEXT = .a
# OBJEXT = .o
# EXEEXT =
# GCCFLAGS = -Wall -MMD -O2 -m32
# LINKFLAGS = -static
# LINKLIB = ld -melf_i386 -r -o $@ $^
# LINKBIN = $(CXX) $(LINKFLAGS) -m32 -o $@ $(LIBS)

# MacOS X 64-bit
# LIBEXT = .a
# OBJEXT = .o
# EXEEXT =
# GCCFLAGS = -Wall -MMD -O2 -force_cpusubtype_ALL -arch x86_64
# LINKFLAGS = -force_cpusubtype_ALL -arch x86_64
# LINKLIB = ld -r -o $@ $^
# LINKBIN = $(CXX) $(LINKFLAGS) -o $@ $(LIBS)

# MacOS X 32-bit
# LIBEXT = .a
# OBJEXT = .o
# EXEEXT =
# GCCFLAGS = -Wall -MMD -O2 -force_cpusubtype_ALL -arch i386 
# LINKFLAGS = -force_cpusubtype_ALL -arch i386 
# LINKLIB = ld -r -o $@ $^
# LINKBIN = $(CXX) $(LINKFLAGS) -o $@ $(LIBS)

# MacOS X PPC
# LIBEXT = .a
# OBJEXT = .o
# EXEEXT =
# GCCFLAGS = -Wall -MMD -O2 -force_cpusubtype_ALL -arch ppc
# LINKFLAGS = -force_cpusubtype_ALL -arch ppc
# LINKLIB = ld -r -o $@ $^
# LINKBIN = $(CXX) $(LINKFLAGS) -o $@ $(LIBS)

# use these for Cygwin:
# LIBEXT = .a
# OBJEXT = .o
# EXEEXT =
# GCCFLAGS = -Wall -MMD -O2 -mno-cygwin
# LINKFLAGS = -mno-cygwin
# LINKLIB = ld -r -o $@ $^
# LINKBIN = $(CXX) $(LINKFLAGS) -o $@ $(LIBS)

# path to proof-logging version of MiniSAT 1.14
MINISAT = ../../MiniSat-p_v1.14

LANGUAGES = ansi-c csp intrep pvs smvlang verilog vhdl netlist cpp specc \
            xmllang promela pascal bplang csharp smtlang nsf mdllang java

# modules that we have
MODULE_CPP = 1
MODULE_VERILOG = 1
