/*******************************************************************\

Module: Verilog Expression Type Checker

Author: Daniel Kroening, kroening@kroening.com

\*******************************************************************/

#include <std_types.h>

#include "vtype.h"

/*******************************************************************\

Function: vtypet::vtypet

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

vtypet::vtypet(const typet &type)
{
  if(type.id()==ID_integer)
  {
    vtype=INTEGER;
    width=0;
  }
  else if(type.id()==ID_unsignedbv)
  {
    vtype=UNSIGNED;
    width=to_unsignedbv_type(type).get_width();
  }
  else if(type.id()==ID_signedbv)
  {
    vtype=SIGNED;
    width=to_signedbv_type(type).get_width();
  }
  else if(type.id()==ID_bool)
  {
    width=1;
    vtype=BOOL;
  }
  else 
  {
    width=0;
    vtype=OTHER;
  }
}

